'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var HTTPStatus = require('http-status');

var _require = require('./utils/helpers'),
    expect = _require.expect;

function digest() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      message = _ref.message,
      _ref$status = _ref.status,
      status = _ref$status === undefined ? HTTPStatus.INTERNAL_SERVER_ERROR : _ref$status,
      data = _ref.data;

  expect({ name: 'message', value: message, type: 'string' });
  expect({ name: 'status', value: status, type: 'number' });
  expect({ name: 'data', value: data, type: 'object', optional: true });
  var code = void 0;
  if (status >= 500 && status < 600) {
    code = 'error';
  } else if (status >= 400 && status < 500) {
    code = 'fail';
  } else {
    throw new Error('Expected "status" parameter to be a number between 400 and 600 but got ' + status + '.');
  }
  return { message: message, status: status, code: code, data: data };
}

module.exports.Response = function (_Error) {
  _inherits(Response, _Error);

  function Response() {
    var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, Response);

    var _digest = digest(args),
        message = _digest.message,
        status = _digest.status,
        code = _digest.code,
        data = _digest.data;

    var _this = _possibleConstructorReturn(this, (Response.__proto__ || Object.getPrototypeOf(Response)).call(this, message));

    _this.status = status;
    _this.code = code;
    if (data) {
      _this.data = data;
    }
    Error.captureStackTrace(_this, Response);
    return _this;
  }

  return Response;
}(Error);

module.exports.BadResponse = function (_Error2) {
  _inherits(BadResponse, _Error2);

  function BadResponse() {
    var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, BadResponse);

    var _digest2 = digest(_extends({}, args, { status: HTTPStatus.BAD_REQUEST })),
        message = _digest2.message,
        status = _digest2.status,
        code = _digest2.code,
        data = _digest2.data;

    var _this2 = _possibleConstructorReturn(this, (BadResponse.__proto__ || Object.getPrototypeOf(BadResponse)).call(this, message));

    _this2.status = status;
    _this2.code = code;
    if (data) {
      _this2.data = data;
    }
    Error.captureStackTrace(_this2, BadResponse);
    return _this2;
  }

  return BadResponse;
}(Error);

module.exports.BreakingResponse = function (_Error3) {
  _inherits(BreakingResponse, _Error3);

  function BreakingResponse() {
    var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, BreakingResponse);

    var _digest3 = digest(_extends({}, args, { status: HTTPStatus.INTERNAL_SERVER_ERROR })),
        message = _digest3.message,
        status = _digest3.status,
        code = _digest3.code,
        data = _digest3.data;

    var _this3 = _possibleConstructorReturn(this, (BreakingResponse.__proto__ || Object.getPrototypeOf(BreakingResponse)).call(this, message));

    _this3.status = status;
    _this3.code = code;
    if (data) {
      _this3.data = data;
    }
    Error.captureStackTrace(_this3, BreakingResponse);
    return _this3;
  }

  return BreakingResponse;
}(Error);

module.exports.NotFoundResponse = function (_Error4) {
  _inherits(NotFoundResponse, _Error4);

  function NotFoundResponse() {
    var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, NotFoundResponse);

    var _digest4 = digest(_extends({}, args, { status: HTTPStatus.NOT_FOUND })),
        message = _digest4.message,
        status = _digest4.status,
        code = _digest4.code,
        data = _digest4.data;

    var _this4 = _possibleConstructorReturn(this, (NotFoundResponse.__proto__ || Object.getPrototypeOf(NotFoundResponse)).call(this, message));

    _this4.status = status;
    _this4.code = code;
    if (data) {
      _this4.data = data;
    }
    Error.captureStackTrace(_this4, NotFoundResponse);
    return _this4;
  }

  return NotFoundResponse;
}(Error);

module.exports.UnauthResponse = function (_Error5) {
  _inherits(UnauthResponse, _Error5);

  function UnauthResponse() {
    var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, UnauthResponse);

    var _digest5 = digest(_extends({}, args, { status: HTTPStatus.UNAUTHORIZED })),
        message = _digest5.message,
        status = _digest5.status,
        code = _digest5.code,
        data = _digest5.data;

    var _this5 = _possibleConstructorReturn(this, (UnauthResponse.__proto__ || Object.getPrototypeOf(UnauthResponse)).call(this, message));

    _this5.status = status;
    _this5.code = code;
    if (data) {
      _this5.data = data;
    }
    Error.captureStackTrace(_this5, UnauthResponse);
    return _this5;
  }

  return UnauthResponse;
}(Error);