'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Resource = require('../resource');

var _require = require('./defaults'),
    login = _require.login,
    register = _require.register,
    logout = _require.logout,
    changePassword = _require.changePassword,
    forgotPassword = _require.forgotPassword,
    resetPassword = _require.resetPassword;

module.exports = function (_Resource) {
  _inherits(UserResource, _Resource);

  function UserResource() {
    _classCallCheck(this, UserResource);

    return _possibleConstructorReturn(this, (UserResource.__proto__ || Object.getPrototypeOf(UserResource)).apply(this, arguments));
  }

  _createClass(UserResource, [{
    key: 'defaults',


    /**
     * Add the user endpoints.
     */
    value: function defaults() {
      var _this2 = this;

      _get(UserResource.prototype.__proto__ || Object.getPrototypeOf(UserResource.prototype), 'defaults', this).call(this);
      this.add({
        id: 'login',
        path: '/login',
        method: 'post',
        open: true,
        handler: function handler() {
          return login(_this2.options).apply(undefined, arguments);
        }
      });
      this.add({
        id: 'register',
        path: '/register',
        method: 'post',
        open: true,
        handler: function handler() {
          return register(_this2.options).apply(undefined, arguments);
        }
      });
      this.add({
        id: 'logout',
        path: '/logout',
        method: 'get',
        open: true,
        handler: function handler() {
          return logout(_this2.options).apply(undefined, arguments);
        }
      });
      this.add({
        id: 'changePassword',
        path: '/password/change',
        method: 'post',
        handler: function handler() {
          return changePassword(_this2.options).apply(undefined, arguments);
        }
      });
      this.add({
        id: 'forgotPassword',
        path: '/password/forgot',
        method: 'post',
        handler: function handler() {
          return forgotPassword(_this2.options).apply(undefined, arguments);
        }
      });
      this.add({
        id: 'resetPassword',
        path: '/password/reset',
        method: 'post',
        handler: function handler() {
          return resetPassword(_this2.options).apply(undefined, arguments);
        }
      });
    }
  }]);

  return UserResource;
}(Resource);